import{s as X,n as Y,o as Z}from"../chunks/scheduler.c57aa7ef.js";import{S as tt,i as et,g as o,s as i,r as v,A as nt,h as r,f as n,c as s,j as S,u as b,x as V,k as j,y as at,a,v as y,d as P,t as M,w}from"../chunks/index.394f8801.js";import{D as Q}from"../chunks/Docstring.46378b0f.js";import{H as W,E as it}from"../chunks/EditOnGithub.157fddbf.js";function st(q){let p,x,T,O,m,E,l,F='<a href="https://huggingface.co/papers/2303.02861" rel="nofollow">Multitask prompt tuning</a>  decomposes the soft prompts of each task into a single learned transferable prompt instead of a separate prompt for each task. The single learned prompt can be adapted for each task by multiplicative low rank updates.',C,u,G="The abstract from the paper is:",L,g,B="<em>Prompt tuning, in which a base pretrained model is adapted to each task via conditioning on learned prompt vectors, has emerged as a promising approach for efficiently adapting large language models to multiple downstream tasks. However, existing methods typically learn soft prompt vectors from scratch, and it has not been clear how to exploit the rich cross-task knowledge with prompt vectors in a multitask learning setting. We propose multitask prompt tuning (MPT), which first learns a single transferable prompt by distilling knowledge from multiple task-specific source prompts. We then learn multiplicative low rank updates to this shared prompt to efficiently adapt it to each downstream target task. Extensive experiments on 23 NLP datasets demonstrate that our proposed approach outperforms the state-of-the-art methods, including the full finetuning baseline in some cases, despite only tuning 0.035% as many task-specific parameters</em>.",H,f,D,d,c,z,_,A,h,k,I,$,U,N,R;return m=new W({props:{title:"Multitask prompt tuning",local:"multitask-prompt-tuning",headingTag:"h1"}}),f=new W({props:{title:"MultitaskPromptTuningConfig",local:"peft.MultitaskPromptTuningConfig",headingTag:"h2"}}),c=new Q({props:{name:"class peft.MultitaskPromptTuningConfig",anchor:"peft.MultitaskPromptTuningConfig",parameters:[{name:"task_type",val:": typing.Union[str, peft.utils.peft_types.TaskType, NoneType] = None"},{name:"peft_type",val:": typing.Union[str, peft.utils.peft_types.PeftType, NoneType] = None"},{name:"auto_mapping",val:": typing.Optional[dict] = None"},{name:"base_model_name_or_path",val:": typing.Optional[str] = None"},{name:"revision",val:": typing.Optional[str] = None"},{name:"inference_mode",val:": bool = False"},{name:"num_virtual_tokens",val:": int = None"},{name:"token_dim",val:": int = None"},{name:"num_transformer_submodules",val:": typing.Optional[int] = None"},{name:"num_attention_heads",val:": typing.Optional[int] = None"},{name:"num_layers",val:": typing.Optional[int] = None"},{name:"prompt_tuning_init",val:": typing.Union[peft.tuners.multitask_prompt_tuning.config.MultitaskPromptTuningInit, str] = <MultitaskPromptTuningInit.RANDOM: 'RANDOM'>"},{name:"prompt_tuning_init_text",val:": typing.Optional[str] = None"},{name:"tokenizer_name_or_path",val:": typing.Optional[str] = None"},{name:"tokenizer_kwargs",val:": typing.Optional[dict] = None"},{name:"prompt_tuning_init_state_dict_path",val:": typing.Optional[str] = None"},{name:"prompt_tuning_init_task",val:": typing.Optional[int] = 0"},{name:"num_ranks",val:": typing.Optional[int] = 1"},{name:"num_tasks",val:": typing.Optional[int] = 1"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/multitask_prompt_tuning/config.py#L36"}}),_=new W({props:{title:"MultitaskPromptEmbedding",local:"peft.tuners.MultitaskPromptEmbedding",headingTag:"h2"}}),k=new Q({props:{name:"class peft.tuners.MultitaskPromptEmbedding",anchor:"peft.tuners.MultitaskPromptEmbedding",parameters:[{name:"config",val:": MultitaskPromptTuningConfig"},{name:"word_embeddings",val:""}],source:"https://github.com/huggingface/peft/blob/main/src/peft/tuners/multitask_prompt_tuning/model.py#L28"}}),$=new it({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/package_reference/multitask_prompt_tuning.md"}}),{c(){p=o("meta"),x=i(),T=o("p"),O=i(),v(m.$$.fragment),E=i(),l=o("p"),l.innerHTML=F,C=i(),u=o("p"),u.textContent=G,L=i(),g=o("p"),g.innerHTML=B,H=i(),v(f.$$.fragment),D=i(),d=o("div"),v(c.$$.fragment),z=i(),v(_.$$.fragment),A=i(),h=o("div"),v(k.$$.fragment),I=i(),v($.$$.fragment),U=i(),N=o("p"),this.h()},l(t){const e=nt("svelte-u9bgzb",document.head);p=r(e,"META",{name:!0,content:!0}),e.forEach(n),x=s(t),T=r(t,"P",{}),S(T).forEach(n),O=s(t),b(m.$$.fragment,t),E=s(t),l=r(t,"P",{"data-svelte-h":!0}),V(l)!=="svelte-pzhgf7"&&(l.innerHTML=F),C=s(t),u=r(t,"P",{"data-svelte-h":!0}),V(u)!=="svelte-1cwsb16"&&(u.textContent=G),L=s(t),g=r(t,"P",{"data-svelte-h":!0}),V(g)!=="svelte-1p005jh"&&(g.innerHTML=B),H=s(t),b(f.$$.fragment,t),D=s(t),d=r(t,"DIV",{class:!0});var J=S(d);b(c.$$.fragment,J),J.forEach(n),z=s(t),b(_.$$.fragment,t),A=s(t),h=r(t,"DIV",{class:!0});var K=S(h);b(k.$$.fragment,K),K.forEach(n),I=s(t),b($.$$.fragment,t),U=s(t),N=r(t,"P",{}),S(N).forEach(n),this.h()},h(){j(p,"name","hf:doc:metadata"),j(p,"content",pt),j(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),j(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,e){at(document.head,p),a(t,x,e),a(t,T,e),a(t,O,e),y(m,t,e),a(t,E,e),a(t,l,e),a(t,C,e),a(t,u,e),a(t,L,e),a(t,g,e),a(t,H,e),y(f,t,e),a(t,D,e),a(t,d,e),y(c,d,null),a(t,z,e),y(_,t,e),a(t,A,e),a(t,h,e),y(k,h,null),a(t,I,e),y($,t,e),a(t,U,e),a(t,N,e),R=!0},p:Y,i(t){R||(P(m.$$.fragment,t),P(f.$$.fragment,t),P(c.$$.fragment,t),P(_.$$.fragment,t),P(k.$$.fragment,t),P($.$$.fragment,t),R=!0)},o(t){M(m.$$.fragment,t),M(f.$$.fragment,t),M(c.$$.fragment,t),M(_.$$.fragment,t),M(k.$$.fragment,t),M($.$$.fragment,t),R=!1},d(t){t&&(n(x),n(T),n(O),n(E),n(l),n(C),n(u),n(L),n(g),n(H),n(D),n(d),n(z),n(A),n(h),n(I),n(U),n(N)),n(p),w(m,t),w(f,t),w(c),w(_,t),w(k),w($,t)}}}const pt='{"title":"Multitask prompt tuning","local":"multitask-prompt-tuning","sections":[{"title":"MultitaskPromptTuningConfig","local":"peft.MultitaskPromptTuningConfig","sections":[],"depth":2},{"title":"MultitaskPromptEmbedding","local":"peft.tuners.MultitaskPromptEmbedding","sections":[],"depth":2}],"depth":1}';function ot(q){return Z(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gt extends tt{constructor(p){super(),et(this,p,ot,st,X,{})}}export{gt as component};
